package com.bcxin.identity.domains.events;

import com.bcxin.Infrastructures.events.DomainEventAbstract;
import com.bcxin.identity.domains.entities.IdentityUserEntity;
import com.bcxin.identity.domains.entities.PrincipalAbstract;
import com.bcxin.identity.domains.enums.EventAction;
import lombok.Getter;

@Getter
public class IdentityUserDomainEvent<T> extends DomainEventAbstract<T> {
    private final EventAction eventAction;
    private final T data;
    private final IdentityUserEntity identityUser;
    private final PrincipalAbstract principal;

    private IdentityUserDomainEvent(EventAction eventAction, T data,
                                   IdentityUserEntity identityUser,
                                   PrincipalAbstract principal) {
        super(data);

        this.eventAction = eventAction;
        this.data = data;
        this.identityUser = identityUser;
        this.principal = principal;
    }

    public static <T> IdentityUserDomainEvent<T> create(EventAction eventAction, T data,
                                                    IdentityUserEntity identityUser,
                                                    PrincipalAbstract principal) {
        return new IdentityUserDomainEvent<>(eventAction, data, identityUser, principal);
    }
}
